package com.tencent.qqmusicplayerprocess.service;

import java.util.List;
import com.tencent.qqmusicplayerprocess.songinfo.SongInfo;
import com.tencent.qqmusicplayerprocess.audio.playlist.MusicPlayList;
import com.tencent.qqmusicplayerprocess.audio.playlist.AsyncLoadList;
import com.tencent.qqmusicplayerprocess.audio.playlist.PlaylistListener;
import com.tencent.qqmusicplayerprocess.audio.progresshelp.ProgressInterface;
import com.tencent.qqmusictv.business.session.Session;
import com.tencent.qqmusiccommon.storage.StorageVolume;
import com.tencent.qqmusictv.business.online.PublicRadioList;
import com.tencent.mediaplayer.AudioInformation;
import com.tencent.qqmusicplayerprocess.service.IQQPlayerThirdCallback;
import com.tencent.qqmusicplayerprocess.service.IMainProcessInterface;

interface IQQPlayerServiceNew
{

	int play(int from);
	int stop(int from);
	int pause(int from);
	int resume(int from);
	int touch();
	int prev(int from);
	int next(int from);
	long seek(long s, int from);
	int playPos(int pos, int from);
	int setPlayList(in MusicPlayList playlist, in SongInfo songinfo, int from);
	int setPlayMode(int playMode, int from);
	MusicPlayList getPlaySongList();
	int getCurPlayPos();
	SongInfo getCurSong();
	SongInfo getPreSong();
	SongInfo getNextSong();
	int getPlayState();
	int getBufferState();
	boolean isPlayingForEngine();
	boolean isPlayingForUI();
	long getTotalLength();
	long getBufferLength();
	int getBufferPercent();
	long getCurrTime();
	long getDuration();
	int getPlayMode();
	int getGlobalPlayMode();
	void setPlayPath(String path, boolean needSave);
	void setTJReport(String report);
	void setTJTJReport(String report);
	void loadRadioListError(in AsyncLoadList playList);
	void loadRadioListSuc(in AsyncLoadList playList, in List<SongInfo> songs, int pos);
	void setRadioList(in PublicRadioList radioList);
	int gotoNextSong(boolean isNext, int from);
	void continueDownloadForNetWorkAvailable();
	void continueDownload();
	SongInfo getPlaySong();
	int initPlayList(in MusicPlayList playList, in SongInfo song, int from);
	int initPlayListAndPlay(in MusicPlayList playList, in SongInfo song, int from);
	int initPlayListAndPlayUsePos(in MusicPlayList playList, int songPos, int from, int playMode);
    int initPlayListAndPlayBySingleRadio(in MusicPlayList playList, int from);
	void onLogout();
	boolean isSongInfoInSamePlayList(in MusicPlayList playList);
	int getSongPos(in SongInfo song);
	MusicPlayList getPlayList();
	void deleteSong(in MusicPlayList list);
	void deleteSongNotExist(in MusicPlayList list);
	void addToList(in MusicPlayList playList);
	int getPlayFocus();
	boolean needDownloadSongToPlayOnline();
	boolean isNullPlayList();
	int getSongBitRate();
	boolean isUseUrlPlayer();
	int playHigherQuality(int quality);
	int clearPlayList();
	void eraseMutilSongs(in List<SongInfo> mMutilChoiceSongList);
	void setHasShow2g3g(boolean hasShow2g3g);
	int getPlayListType();
	long getPlayListTypeId();
	String getPlayListFolderName();
	long getPlayListFolderId();
	int getPlayListSize();
	void loadLastList();	
	void setPlayListPartially(in MusicPlayList playList);
	List<SongInfo> getPlayListPartially(int start, int end);
    List<SongInfo> getRadioHistoryList();
    boolean isInNextPlaySongList(in SongInfo song);
    int getNextSongListNum();
    String getRadioName();
    String getRadioUrl();
    long getRadioId();
    void popSongFromHistory(in SongInfo song);
    void deleteRadioSong(in SongInfo song); 
    SongInfo getSingleRadioSong();
	void clearCache();
	void setUserData(long qqNum, boolean isVIP);
	boolean updatePlayListAndPlay(in SongInfo newSongInfo,int index, int from); //rubik 鏂板锛氭洿鏂版挱鏀炬瓕鏇蹭俊鎭�
	
	//For vKey
	String getServerCheck();
	int urlCannotDownload(String url, int respCode);
	void networkChangedForVkey();
	String getSpeedTestUrl();
	String getVKey();
	String getContKey(String filename,int ipaid);
	String getVKeyPair();
	String getVKeyUin();
	String getVKeyForWX(String guid);
	void forceToUpdateVkey();
	
	//For sdcard 
	boolean isSdcardAvailable();
	String getSdCardState();
	
	List<String> getStoragePaths();
	List<String> getRawStoragePaths();
	List<StorageVolume> getStorageVolumes();
	boolean setBigDataStoragePath(String path);
	String getStoragePath();
	String getBigDataStoragePath();
	String getMainPath();
	String getBigDataMainPath();
	String getFilePath(int index);
	String getBackupLocationPath(String p, boolean needChangeCurStoragepath);
	
	//For statistics manager
	long getSendFrequence();
	void setSendFrequence(long fre);
	void debugSendLog();
	void pushLog(String logInfo, boolean force);
	void pushFrom(int curIndex);
	void popFromByIndex(int curIndex);
	void popFrom();
	String from();
	int getLatestPathPoint();
	String fromPrePath(boolean needPrePath);
	void setPrePath(String path);
		
	void setProgressInterface(ProgressInterface progressInterface);
	void removeProgressInterface(ProgressInterface progressInterface);
    
    void registerCallback(PlaylistListener listener);
    void unRegisterCallback(PlaylistListener listener);
    
    void registerMainProcessInterface(IMainProcessInterface iface);
    void unRegisterMainProcessInterface(IMainProcessInterface iface); 
      
    boolean isHeadsetPlauged();
    void setVolume(float vol);
    String getWeakQQ();
    boolean isPreferenceLocked();
    
    void onLoginStateChanged(String curStringQQNum);

    Bitmap getNotifyAlbumBitmap();
    void setNotifyAlbumBitmap(in Bitmap b);
	boolean isChangeToHardDecodeEnabled();
    void setChangeToHardDecodeEnabled(boolean changeToHardDecodeEnabled);
    AudioInformation getCurrentAudioInformation();

	void addNextPlaySong(in MusicPlayList playList);
	
	
	AudioInformation getAudioInformation(String filePath);
	String getAudioFormat(String filePath);
	
	void updateSongInfoIfSamePlayList(in MusicPlayList list);//鏉冮檺鍙戠敓鍙樺寲鍚庢洿鏂版挱鏀惧垪琛�

	void updatePlayListAfterScan(in List<SongInfo> oldSongList, in List<SongInfo> newSongList);

	boolean BluetoothA2DPConnected();
	boolean isPausedByTransientLossOfFocus();
	void notifyMetaChangeToSystem(String title);

    int getSessionId();

	String getBufferMessage();
	
	String getCurrentVkey();
	void setQQMusicUIConfig(int width, int height, float density);
}

